package jpwang.sino;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.database.Cursor;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;

public class JPWangActivity extends Activity {
	/** Called when the activity is first created. */

	private MyDB db = null;

	ListView lv01;
	Button btnINS, btnDEL, btnMDY, btnCLR, btnFind;
	EditText edtNAME, edtPRICE;
	String str, itemdata;
	Cursor cursor;
	long myid; // xs id 
	int n = 1;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		lv01 = (ListView) findViewById(R.id.lv01);
		btnINS = (Button) findViewById(R.id.btnINS);
		btnMDY = (Button) findViewById(R.id.btnMDY);
		btnDEL = (Button) findViewById(R.id.btnDEL);
		btnCLR = (Button) findViewById(R.id.btnCLR);
		btnFind = (Button) findViewById(R.id.btnFind);
		edtNAME = (EditText) findViewById(R.id.edtNAME);
		edtPRICE = (EditText) findViewById(R.id.edtPRICE);

		btnINS.setOnClickListener(btnqueryClick);
		btnMDY.setOnClickListener(btnqueryClick);
		btnDEL.setOnClickListener(btnqueryClick);
		btnCLR.setOnClickListener(btnqueryClick);
		btnFind.setOnClickListener(btnqueryClick);

		lv01.setOnItemClickListener(lv01Listener);

		db = new MyDB(this);
		db.open();
		cursor = db.getAll(); //
		UpdateAdapter(cursor); // ܥ
	}

	private Button.OnClickListener btnqueryClick = new Button.OnClickListener() {
		public void onClick(View v) {
			// TODO Auto-generated method stub
			switch (v.getId()) {
			case R.id.btnFind: {
				String str = "";
				if (edtNAME.getText().toString() != ""){
					str = str + " name like " + "'%" + edtNAME.getText().toString()+"%'";
					cursor = db.getStr(str);
					UpdateAdapter(cursor);
					ClearEdit();					
							}else{};
				break;
			}

			case R.id.btnINS: {
				int price = Integer.parseInt(edtPRICE.getText().toString());
				String name = edtNAME.getText().toString();

				if (db.append(name, price) > 0) {
					cursor = db.getAll();
					UpdateAdapter(cursor);
					ClearEdit();
				}
				break;
			}
			
			case R.id.btnMDY: {
				int price = Integer.parseInt(edtPRICE.getText().toString());
				String name = edtNAME.getText().toString();

				if (db.update(myid, name, price)) {
					cursor = db.getAll();
					UpdateAdapter(cursor);
					ClearEdit();
				}
				break;
			}
			
			case R.id.btnDEL: {
				if (cursor != null && cursor.getCount() >= 0) {
					AlertDialog.Builder builder = new AlertDialog.Builder(JPWangActivity.this);

					builder.setTitle("TwR");
					builder.setMessage("TwnR" + edtNAME.getText().toString() + "o?");
					
					builder.setNegativeButton("",
							new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialogInterface,
										int i) {
								}
							});
					builder.setPositiveButton("T{",
							new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialogInterface,
										int i) {
									if (db.delete(myid)){
										cursor = db.getAll();
										UpdateAdapter(cursor);
										ClearEdit();
									}
								}
							});
					builder.show();
				}

				break;
			}
			
			}

		}
	};

	public void ClearEdit() {
		edtNAME.setText("");
		edtPRICE.setText("");
	}

	public void UpdateAdapter(Cursor cursor) {
		if (cursor != null && cursor.getCount() >= 0) {
			SimpleCursorAdapter adapter = new SimpleCursorAdapter(this,
					android.R.layout.simple_expandable_list_item_2, cursor,
					new String[] { "name", "price" }, new int[] {
							android.R.id.text1, android.R.id.text2 });
			lv01.setAdapter(adapter);
		}
	}

	private void ShowData(long id) {
		// ܳ浧
		Cursor c = db.get(id);
		myid = id; // oid
		edtNAME.setText(c.getString(1));
		edtPRICE.setText("" + c.getInt(2));

	}

	protected void onDestory() {
		super.onDestroy();
		db.close();
	}
	private ListView.OnItemClickListener lv01Listener = new ListView.OnItemClickListener() {
		public void onItemClick(android.widget.AdapterView<?> parent, View v,
				int position, long id) {
			ShowData(id);
			cursor.moveToPosition(position);
		};

	};

}